﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TSLab.Script;
using TSLab.Script.Handlers;

namespace RusAlgo.Handlers
{
    // Индюкатор выдает ОИ инструмента как сам инструмент. В итоге видим свечки на графике по ОИ и объемы
    [HandlerCategory("RusAlgo")]
    [HandlerName("OI Candles")]
    public class CandleOi : IOneSourceHandler, ISecurityInputs, ISecurityReturns, IStreamHandler, IContextUses
    {
        public IContext Context { set; private get; }

        public ISecurity Execute(ISecurity sec)
        {
            var oiBars = new Bar[Context.BarsCount];
            oiBars[0] = new Bar(sec.Bars[0].Color, sec.Bars[0].Date, sec.Bars[1].Interest, sec.Bars[1].Interest, sec.Bars[1].Interest, sec.Bars[1].Interest, 0);
            for (int i = 1; i < Context.BarsCount; i++)
            {
                var col = sec.Bars[i].Color;
                var date = sec.Bars[i].Date;
                var oiOpen = sec.Bars[i - 1].Interest;
                var oiClose = sec.Bars[i].Interest;
                var oiHigh = Math.Max(oiOpen, oiClose);
                var oiLow = Math.Min(oiOpen, oiClose);
                var oiVolume = Math.Abs(oiClose - oiOpen);

                var bar = new Bar(col, date, oiOpen, oiHigh, oiLow, oiClose, oiVolume);

                oiBars[i] = bar;
            }

            // клонируем с подменой баров, получаем типо инструмент, но свечи иные.
            var oiSec = sec.CloneAndReplaceBars(oiBars);
            return oiSec;
        }
    }
}
