﻿using System;
using System.Collections.Generic;
using System.Media;
using System.Text;
using TSLab.Script;
using TSLab.Script.Handlers;

namespace RusAlgo.Handlers
{
    [HandlerCategory("RusAlgo")]
    [HandlerName("Messanger")]
    public class Messanger : IOneSourceHandler, IBooleanInputs, IValuesHandlerWithNumber, IBooleanReturns, IContextUses
    {
        public IContext Context { set; private get; }

        [HandlerParameter(Name = "Текст сообщения", Default = "message", NotOptimized = true)]
        public string Message { get; set; }

        public bool Execute(bool signal, int barNum)
        {
            if (!signal)
                return signal;

            var lastBarIndex = Context.BarsCount - 1;

            // Для режима пересчета по обычному интервалу, бипать нужно когда сигнал сгенерен на последней свече.
            // Но если мы по тикам, интервал + сделка и так далее, То сигнал не генерится на последней свече, он на предпоследней.
            if (Context.IsLastBarUsed)
            {
                if (barNum == lastBarIndex)
                    Context.Log(Message, new Color());
            }
            else
            {
                if (barNum == lastBarIndex-1)
                    Context.Log(Message, new Color());
            }

            return signal;
        }
    }
}
